; Program za pretvorbu ASCII-znakova u BCD broj, verzija 1

	AREA atobcd_v1, CODE, READONLY
	
	ENTRY
	
ADDR EQU 0x8100				; adresa na kojoj se nalaze podatci
	
	MOV R4, #ADDR   		; postavlja R4 na pocetak podataka
	MOV R7, #8				; brojac BCD znamenaka = 8 
	MOV R6, #0				; resetiranje rezultata
PETLJA
	LDRB R0, [R4], #1	; ucitavanje ASCII-znaka
	SUB R0, R0, #0x30	; ASCII:0 = BCD:30
	ADD R6, R0, R6, LSL #4	; spremanje rezultata u registar
									; (pomak trenutacnog rezultata za 
									; 4 bita)	
	SUBS R7, R7, #1		; brojac prolaza petlje
	BHI PETLJA 

KRAJ
	STR R6, [R4]			; spremanje rezultata

	MOV R0, #0x18			; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI
		
	END

