; Pretvara BCD u ASCII hexadekadski broj, verzija 1
; UVJET ZADATKA: ulazni broj i adresa na koju se spremaju podatci
; su zapisani u memoriji odmah nakon poziva potprograma

	AREA bcdtoa_v1, CODE, READWRITE

	ENTRY

GLAVNI	
	BL FUNC_BCDTOA
	DCD 0x12340987		; podatak koji se pretvara
	DCD 0x8100		; adresa na koju se spremaju podatci
	
	MOV R0, #0x18		; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI
	

FUNC_BCDTOA
	LDR R5, [R14]		; ucitava podatak za pretvorbu
	LDR R4, [R14, #4]	; postavlja registar R4 na pocetak podrucja za podatke

	ADD R14, R14, #8	; prilagodba povratne adrese
	MOV R6, #8		; brojac prolazaka kroz petlju
PETLJA
	AND R0, R5, #0xf	; maskiranje bitova
	ADD R0, R0, #0x30	; dodaj 0x30
	STRB R0, [R4], #1	; sprema ASCII-znamenku u memoriju
	MOV R5, R5, LSR #4	; na najnize bitove stavlja se nova znamenka
	SUBS R6, R6, #1		; smanjuje se brojac prolaza
	BHI PETLJA		; ako je brojac veci od nule, ponavlja petlju

	MOV PC,R14		; povratak iz potprograma
		
	END


