; Program za mnozenje 16-bitnih brojeva metodom zbrajanja, v.2
; - Uvjet zadatka: multiplikator je broj bez predznaka
; - U programu se koristi uvjetno izvodenje naredaba 

	AREA mult_16_v2, CODE, READWRITE
ADDR EQU 0x8100				; adresa na kojoj se nalaze podatci
	ENTRY

	MOV R4, #ADDR   		; postavlja u R4 adresu podataka
	LDRH R5, [R4], #2	; multiplikator se ucitava u R5
	LDRSH R6, [R4], #2	; multiplikand se ucitava u R6
									;(predznak sacuvan)
	MOV R7, #0				; cisti se registar za spremanje
									; rezultata (R7)
PETLJA	
	CMP R5, #0				; usporedba multiplikatora i nule
	ADDHI R7, R7, R6		; ako je zadovoljen uvjet HI, pribroji 
				; multiplikand rezultatu. Napomena: koristi
				; se uvjetno izvodenje naredbe. Ako uvjet nije 
				; zadovoljen, procesor ne radi nista
	SUBHI R5, R5, #1	; ako je zadovoljen uvjet HI, umanji 
				; multiplikator za jedan, ne postavljaju 
				; se zastavice!!!
	BHI PETLJA				; ako je HI, ponovi petlju
	STR R7, [R4]			; spremanje rezultata

kraj
	MOV R0, #0x18			; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI
		
	END

