;Program za 16-bitno zbrajanje brojeva s predznakom, ver. 1

	AREA add_16s_v1, CODE, READWRITE	; definicije asembleru
	ENTRY					;oznaka pocetka programskog odsjecka

	LDRSH R0, A			; prvi operand se ucitava u R0 i on je
								; prosiren s predznakom na 32 bita 
								; (za unsigned se koristi LDRH)
	LDRSH R1, B			; drugi operand se ucitava u R1 i on je
								; prosiren s predznakom na 32 bita 
								; (za unsigned se koristi LDRH)
	ADDS R4, R0, R1	; izvodi se zbrajanje i postavljaju se
								; zastavice (S)
	STR R4, REZ		; rezultat se sprema u memoriju
kraj								; priprema za izlaz iz programa
	MOV R0, #0x18		; angel_SWIreason_ReportException
	LDR R1, =0x20026	; ADP_Stopped_ApplicationExit
	SWI 0x123456		; izvodenje SWI i izlaz iz programa
	
A	DCW -100				; prvi operand (polurijec)
B	DCW 0x20				; drugi operand (polurijec)
REZ	SPACE 4					; rezultat (rijec)

	END

